//https://codepen.io/wallstreetrader/pen/JjLYada?editors=0010
import { TrackballControls } from "https://cdn.skypack.dev/three-trackballcontrols-ts@0.2.3";
let scene, camera, renderer, cube, controls;

let addTrackBall = _ => {
  //Trackball Controls for Camera 
  controls = new TrackballControls(camera, renderer.domElement);
  controls.rotateSpeed = 4;
  controls.dynamicDampingFactor = 0.15;
}
let createBox = _ => {
  const colorYellow = new THREE.Color("hsl(40, 100%, 60%)");
  const colorLight = new THREE.Color("hsl(41, 100%, 95%)");
  const boxGeometry = new THREE.BoxGeometry(2, 2, 2);
  const boxMaterial = new THREE.MeshPhongMaterial({ color: colorYellow, shininess: 60 });
  cube = new THREE.Mesh(boxGeometry, boxMaterial);
  cube.rotation.set(40, 0, 40);
  scene.add(cube);

  const light = new THREE.PointLight(colorLight, 2);
  const light2 = new THREE.PointLight(colorLight, .5);
  light.position.set(-40, -20, 20);
  light2.position.set(40, 20, 15);
  scene.add(light);
  scene.add(light2);
}
let init = () => {
  scene = new THREE.Scene();
  camera = new THREE.PerspectiveCamera(75, window.innerWidth / window.innerHeight, 0.1, 1000);
  camera.position.z = 5;
  renderer = new THREE.WebGLRenderer({ antialias: true });
  renderer.setSize(window.innerWidth, window.innerHeight);
  document.body.appendChild(renderer.domElement);
  createBox();
  addTrackBall();
  window.addEventListener('resize', onWindowResize, false);
}

function animate() {
  requestAnimationFrame(animate);
  renderer.render(scene, camera);
  cube.rotation.x += 0.01;
  cube.rotation.y += 0.01;
  // Update trackball controls
  controls.update();
}

let onWindowResize = () => {
  camera.aspect = window.innerWidth / window.innerHeight;
  camera.updateProjectionMatrix();
  renderer.setSize(window.innerWidth, window.innerHeight);
}

init();
animate();